#ifndef TREE_HPP
#define TREE_HPP

#include "node.hpp"

#include <vector>

class Tree {
public:
    // constructor
    Tree() = delete;
    Tree(double* masses, double* particles, double* forces_, unsigned nParticles, double size, double* center);
    // destructor
    ~Tree();
    // calculate force on a particle
    void calculateForce(unsigned particle);
    // update tree
    void update();

private:
    Node* root_;

    double* masses_;
    double* particles_;
    double* forces_;
    unsigned nParticles_;

    double size_;
    double center_[3];
    
    std::vector<unsigned> allParticles_;
};

#endif /* TREE_HPP */